pulseaudio-tcp/pulseaudio-tcp
2025-03-30 15:33:34 +02:00

549 lines
14 KiB
Bash

#!/bin/bash
# shellcheck disable=SC1090
# shellcheck disable=SC2154
# Setup and run encrypted connection to remote PulseAudio/Pipewire server
# Copyright (C) 2023-2025 Tilman Kranz <t.kranz@tk-sls.de>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <https://www.gnu.org/licenses/>.
##
# Functions
usage() {
cat >&2 <<EOF
Usage: $0 [OPTIONS] OPERATION
Options:
--debug Enable additional debug output for start and stop operations.
--no-gui Do not display GUI dialogs, use terminal for input and output.
Operations:
setup Interactively gather settings.
start Start redirection to remote host.
stop Stop redirection to remote host.
restart Stop and then start redirection.
status Check if redirection is set up and enabled.
EOF
}
log() {
level=$1
shift
msg=$*
echo "$level: $msg" >&2
if [[ -t 1 ]] && $gui && [[ -n $(type -p zenity) ]] ; then
case "$level" in
ERROR)
zenity --error --text="$msg"
;;
*)
zenity --info --text="$msg"
;;
esac
fi
}
error() {
log ERROR "$@"
}
info() {
log INFO "$@"
}
debug() {
if "$debug" ; then
log DEBUG "$@"
else
gui=false log DEBUG "$@"
fi
}
_ssh() {
if ssh -S "$USER"-pulseaudio "$remote_user"@"$remote_ip" "$@" ; then
return 0
else
error "SSH remote_ip=$remote_ip failed."
return 1
fi
}
question_yesno() {
question=$*
if "$gui" ; then
if zenity --question --text="$question" ; then
return 0
else
return 1
fi
else
while read -r -p "$question [y|n] " answer ; do
case $answer in
[yY])
return 0
;;
[nN])
return 1
;;
esac
done
fi
}
question_input() {
title=$1
question=$2
value=$3
if $gui ; then
zenity --entry --title="$title" --text="$question" --entry-text="$value"
else
echo "$title" >&2
read -r -p "$question ($value)" answer
[[ -z $answer ]] && answer=$value
echo "$answer"
fi
}
# Perform setup operation
do_setup() {
if test -e "$config" ; then
if question_yesno "$config already exists, overwrite it?"; then
if ! test -w "$config" ; then
error "$config is not writable."
return 1 ;
elif ! test -r "$config" ; then
error "$config is not readable."
return 1 ;
else
. "$config"
fi
else
error "Setup aborted."
return 1
fi
elif ! test -e "$config_dir" ; then
mkdir -p "$config_dir" || {
error "Could not create $config_dir"
return 1 ;
}
elif ! test -d "$config_dir" ; then
error "$config_dir is not a directory"
return 1
elif ! test -w "$config_dir" ; then
error "$config_dir is not writable"
return 1
fi
while true ; do
if remote_ip_in=$(question_input "Set remote host" "Enter name or IP address of remote host:" "$remote_ip") ; then
break
fi
done
while true ; do
if remote_user_in=$(question_input "Set remote user" "Enter username on remote host:" "$remote_user") ; then
break
fi
done
inbound=${inbound:-true}
while true ; do
if question_yesno "Enable inbound audio?"; then
inbound_in=true
break
else
inbound_in=false
break
fi
done
outbound=${outbound:-true}
while true ; do
if question_yesno "Enable outbound audio?"; then
outbound_in=true
break
else
outbound_in=false
break
fi
done
cat > "$config" << EOF
# Configuration file for pulseaudio-tcp
# Generated on $(LC_ALL=C date) by $USER using $0
# IP address of remote host
remote_ip="$remote_ip_in"
# Username on remote host
remote_user="$remote_user_in"
# Enable inbound audio from $remote_user @$remote_ip?
inbound=$inbound_in
# Enable outbound audio to $remote_user @$remote_ip?
outbound=$outbound_in
EOF
}
# Check if SSH port forwarding is running
check_pa_ssh() {
for pid in $(pidof ssh) ; do
if grep -Fq "$USER"-pulseaudio /proc/"$pid"/cmdline && grep -Fq -e -L /proc/"$pid"/cmdline ; then
return 0
fi
done
return 1
}
# Perform status operation
do_status() {
rv=0
errors=()
if ! check_pa_ssh ; then
rv=1
fi
if ! _ssh pactl list modules | grep -Fq "Name: module-native-protocol-tcp" ; then
errors+=("PulseAudio module \"module-native-protocol-tcp\" is not loaded on remote host $remote_ip.")
rv=1
fi
if "$outbound" ; then
if ! pactl list modules | grep -Fq "Name: module-tunnel-sink" ; then
errors+=("PulseAudio module \"module-tunnel-sink\" is not loaded.")
rv=1
fi
if ! pactl get-default-sink | grep -Fq "tunnel-sink.tcp:127.0.0.1" ; then
errors+=("\"tunnel-sink.tcp:127.0.0.1\" is not the default PulseAudio sink.")
rv=1
fi
fi
if "$inbound" ; then
if ! pactl list modules | grep -Fq "Name: module-tunnel-source" ; then
errors+=("PulseAudio module \"module-tunnel-source\" is not loaded.")
rv=1
fi
fi
if [[ $rv -eq 0 ]] ; then
info "All checks passed; pulseaudio-tcp status is okay."
else
error "pulseaudio-tcp status is not okay: ${errors[*]}"
fi
return "$rv"
}
# Acquire PulseAudio cookie from remote host
sync_pa_cookie() {
if scp -q "$remote_user"@"$remote_ip":.config/pulse/cookie ~/.config/pulse/cookie ; then
debug "Synced PulseAudio cookie from remote host $remote_ip."
return 0
else
error "Unable to sync PulseAudio cookie from remote host $remote_ip."
return 1
fi
}
# Establish SSH port forwarding to PulseAudio TCP server on remote host
establish_ssh_portforward() {
_ssh -fNT -L 127.0.0.1:4713:127.0.0.1:4713
}
# Enable PulseAudio TCP tunnel server on remote host
enable_remote_pa_tunnel_server() {
if _ssh pactl list modules | grep -Fq "Name: module-native-protocol-tcp" ; then
debug "PulseAudio module \"module-native-protocol-tcp\" already loaded on remote host $remote_ip."
return 0
elif _ssh pactl load-module module-native-protocol-tcp listen=127.0.0.1 auth-ip-acl=127.0.0.1 ; then
debug "Loaded PulseAudio module \"module-native-protocol-tcp\" on remote host $remote_ip."
return 0
else
error "Unable to load PulseAudio module \"module-native-protocol-tcp\" on remote host $remote_ip."
return 1
fi
}
# Enable tunnel sink on local host
enable_local_pa_tunnel_sink() {
if pactl list modules | grep -Fq "Name: module-tunnel-sink" ; then
debug "PulseAudio module \"module-tunnel-sink\" already loaded."
return 0
elif pactl load-module module-tunnel-sink server=tcp:127.0.0.1 ; then
debug "Loaded PulseAudio module \"module-tunnel-sink\"."
return 0
else
error "Unable to load PulseAudio module \"module-tunnel-sink\"."
return 1
fi
}
# Enable tunnel source on local host
enable_local_pa_tunnel_source() {
if pactl list modules | grep -Fq "Name: module-tunnel-source" ; then
debug "PulseAudio module \"module-tunnel-source\" already loaded."
return 0
elif pactl load-module module-tunnel-source server=tcp:127.0.0.1 ; then
debug "Loaded PulseAudio module \"module-tunnel-source\"."
return 0
else
error "Unable to load PulseAudio module \"module-tunnel-source\"."
return 1
fi
}
# Set tunnel sink as default sink on local host
set_local_pa_tunnel_sink_as_default() {
if pactl set-default-sink tunnel-sink.tcp:127.0.0.1 ; then
debug "Set \"tunnel-sink.tcp:127.0.0.1\" as default PulseAudio sink."
return 0
else
error "Failed to set \"tunnel-sink.tcp:127.0.0.1\" as default PulseAudio sink."
return 1
fi
}
# Perform start operation
do_start() {
sync_pa_cookie || return 1
establish_ssh_portforward || return 1
enable_remote_pa_tunnel_server || return 1
if "$outbound" ; then
enable_local_pa_tunnel_sink || return 1
# workaround, local tunnel is not available immediately
sleep 1
set_local_pa_tunnel_sink_as_default || return 1
fi
if "$inbound" ; then
enable_local_pa_tunnel_source || return 1
fi
return 0
}
# Remove PulseAudio TCP tunnel sink on local host
remove_local_pa_tunnel_sink() {
if ! pactl list modules | grep -Fq "Name: module-tunnel-sink" ; then
debug " PulseAudio module \"module-tunnel-sink\" is not loaded."
return 0
elif ! pactl list sinks | grep -Fq "tunnel-sink.tcp:127.0.0.1" ; then
debug "No PulseAudio tunnel sink to 127.0.0.1 exists."
return 0
else
owner_module=$(
pactl --format json list sinks 2>/dev/null | \
jq '.[] | select(.name=="tunnel-sink.tcp:127.0.0.1") | .owner_module' -r
)
if ! pactl unload-module "$owner_module" ; then
error "Could not unload owner module $owner_module of PulseAudio sink \"tunnel-sink.tcp:127.0.0.1\"."
return 1
else
debug "Unloaded owner module $owner_module of PulseAudio sink \"tunnel-sink.tcp:127.0.0.1\"."
return 0
fi
fi
}
# Remove PulseAudio TCP tunnel source on local host
remove_local_pa_tunnel_source() {
if ! pactl list modules | grep -Fq "Name: module-tunnel-source" ; then
debug "PulseAudio module \"module-tunnel-source\" is not loaded."
return 0
elif ! pactl list sources | grep -Fq "tunnel-source.tcp:127.0.0.1" ; then
debug "No PulseAudio tunnel source from 127.0.0.1 exists."
return 0
else
owner_module=$(
pactl --format json list sources 2>/dev/null | \
jq '.[] | select(.name=="tunnel-source.tcp:127.0.0.1") | .owner_module' -r
)
if ! pactl unload-module "$owner_module" ; then
error "Could not unload owner module $owner_module of PulseAudio source \"tunnel-source.tcp:127.0.0.1\"."
return 1
else
debug "Unloaded owner module $owner_module of PulseAudio source \"tunnel-source.tcp:127.0.0.1\"."
return 0
fi
fi
}
# Stop PulseAudio TCP tunnel server on remote host.
disable_remote_pa_tunnel_server() {
if ! _ssh pactl list modules | grep -Fq "Name: module-native-protocol-tcp" ; then
debug "PulseAudio module \"module-native-protocol-tcp\" not loaded on remote_ip=$remote_ip."
return 0
elif ! _ssh pactl unload-module module-native-protocol-tcp ; then
error "Could not unload PulseAudio module \"module-native-protocol-tcp\" on remote host $remote_ip."
return 1
else
debug "Unloaded PulseAudio module \"module-native-protocol-tcp\" on remote host $remote_ip."
return 0
fi
}
# Terminate SSH portforwarding session
terminate_ssh_portforward() {
for pid in $(pidof ssh) ; do
if grep -Fq "$USER"-pulseaudio /proc/"$pid"/cmdline ; then
kill -TERM "$pid"
fi
done
}
# Perform stop operation
do_stop() {
if "$outbound" ; then
remove_local_pa_tunnel_sink || return 1
fi
if "$inbound" ; then
remove_local_pa_tunnel_source || return 1
fi
disable_remote_pa_tunnel_server || return 1
terminate_ssh_portforward || return 1
return 0
}
##
# Arguments
for arg in "$@" ; do
case "$arg" in
--debug)
debug_cmdline=true
;;
--no-gui)
gui_cmdline=false
;;
--help)
help_cmdline=true
;;
*)
operation=$arg
;;
esac
done
##
# Configuration
config_dir="$HOME"/.config/pulseaudio-tcp
config=$config_dir/config.inc.sh
if [[ $help_cmdline = true ]] ; then
usage
exit 0
fi
if [[ $debug_cmdline = true ]] ; then
debug=true
else
debug=false
fi
if [[ $gui_cmdline = false ]] ; then
gui=false
else
gui=true
fi
##
# Main Program
rv=0
if test "$operation" = setup ; then
info "Entering setup mode ..."
else
if ! test -e "$config" ; then
error "Configfile $config does not exist (use \"$0 setup\" first)."
rv=1
elif ! test -r "$config" ; then
error "Configfile $config is not readable."
rv=1
elif ! test -f "$config" ; then
error "Configfile $config is not a regular file."
rv=1
else
. "$config"
if [[ -z $remote_ip ]] ; then
error "\"remote_ip=<IP address>\" not set in configfile $config."
rv=1
elif [[ -z $remote_user ]] ; then
error "\"remote_user=<username>\" not set in configfile $config."
rv=1
fi
fi
required_cmds=( jq pactl ssh )
"$gui" && required_cmds+=( zenity )
for exe in "${required_cmds[@]}" ; do
if [[ -z $(type -p "$exe") ]] ; then
error "Required executable \"$exe\" not found."
rv=1
fi
done
fi
if [[ $rv -ne 0 ]] ; then
error "Preliminary checks failed, skipping operation."
else
case "$operation" in
setup)
do_setup
rv=$?
;;
start)
do_start
rv=$?
;;
stop)
do_stop
rv=$?
;;
restart)
do_stop
do_start
rv=$?
;;
status)
do_status
rv=$?
;;
*)
usage
rv=1
;;
esac
fi
exit "$rv"